SystemOrganization addCategory: #'Seaside-JSON-Core'!

!Collection methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:20'!
jsonOn: aRenderer 
	aRenderer array: [
		self do: [ :each |
			aRenderer value: each ] ]! !

!Character methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 16:31'!
jsonOn: aRenderer
	aRenderer string: (String with: self)! !

!GRSmallDictionary methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:24'!
jsonOn: aRenderer
	aRenderer object: [
		self keysAndValuesDo: [ :key :value |
			aRenderer key: key value: value ] ]! !

WACanvas subclass: #WAJsonCanvas
	instanceVariableNames: 'first'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonCanvas class methodsFor: 'instance creation' stamp: 'pmm 2/18/2012 15:47'!
builder
	^ (WABuilder on: self)
		documentClass: WAJsonDocument;
		yourself! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:57'!
array: aBlock
	^ (self brush: WAJsonArrayBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'double-disptach' stamp: 'pmm 2/18/2012 14:47'!
boolean: aBoolean
	self document stream nextPutAll: (aBoolean ifTrue: [ 'true' ] ifFalse: [ 'false' ])! !

!WAJsonCanvas methodsFor: 'initialization' stamp: 'pmm 8/24/2011 15:05'!
initializeWithContext: aRenderContext
	super initializeWithContext: aRenderContext.
	first := true! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 15:15'!
key: aKeyString value: aValueObject
	^ (self brush: (WAJsonKeyValueBrush key: aKeyString)) with: aValueObject! !

!WAJsonCanvas methodsFor: 'private' stamp: 'pmm 1/22/2012 16:28'!
nest: aBlock
	first := true.
	super nest: aBlock.
	first := false! !

!WAJsonCanvas methodsFor: 'double-disptach' stamp: 'pmm 2/18/2012 14:47'!
null
	self document stream nextPutAll: 'null'! !

!WAJsonCanvas methodsFor: 'double-disptach' stamp: 'pmm 2/18/2012 14:51'!
number: aNumber
	aNumber printOn: self document stream! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 13:58'!
object: aBlock
	^ (self brush: WAJsonObjectBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 2/18/2012 15:16'!
render: anObject
	self flush.
	anObject jsonOn: self! !

!WAJsonCanvas methodsFor: 'double-disptach' stamp: 'pmm 5/6/2012 15:30'!
string: aString
	self document string: aString! !

!WAJsonCanvas methodsFor: 'public' stamp: 'pmm 8/24/2011 14:25'!
value: aBlock
	^ (self brush: WAJsonValueBrush new) with: aBlock! !

!WAJsonCanvas methodsFor: 'private' stamp: 'pmm 8/24/2011 15:07'!
writeIfNotFirst: aString
	first ifFalse: [
		self document nextPutAll: aString ]! !

!Float methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:23'!
jsonOn: aRenderer
	aRenderer number: self! !

!BlockClosure methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:16'!
jsonOn: aRenderer
	self numArgs = 0
		ifTrue: [ self value ]
		ifFalse: [ self value: aRenderer ]! !

!Dictionary methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:23'!
jsonOn: aRenderer
	aRenderer object: [
		self keysAndValuesDo: [ :key :value |
			aRenderer key: key value: value ] ]! !

!GRPlatform methodsFor: '*seaside-json-core' stamp: 'pmm 5/6/2012 15:28'!
jsonEncoderOn: aStream
	"Answer an JSON encoder that works on aStream.
	Platforms may provide optimized implementations."
	^ WAJsonEncoder on: aStream! !

!GRPackage class methodsFor: '*seaside-json-core' stamp: 'pmm 5/6/2012 15:58'!
seasideJsonCore
	^ self new
		name: 'Seaside-JSON-Core';
		description: 'JSON integration in Seaside. Provides a basic functionality to generate JSON from Smalltalk.';
		addDependency: 'Seaside-Core';
		addDependency: 'Seaside-Canvas';
		url: #seasideUrl;
		yourself! !

!UndefinedObject methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:25'!
jsonOn: aRenderer
	aRenderer null! !

!WAUrl methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:27'!
jsonOn: aRenderer
	aRenderer string: self printString! !

WATableBasedEncoder subclass: #WAJsonEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonEncoder class methodsFor: 'initialization' stamp: 'pmm 5/6/2012 15:21'!
initialize
	self initializeTable! !

!WAJsonEncoder class methodsFor: 'initialization' stamp: 'pmm 5/6/2012 15:25'!
initializeTable
	| printer escapes |
	printer := GRNumberPrinter new.
	printer base: 16; padding: $0; digits: 2.
	table := Array new: self maximumCharacterValue + 1.
	"write control characters"
	0 to: 31 do: [ :index | 
		table 
			at: index + 1
			put: '\x' , (printer print: index) ].

	"overwrite named (control) characters"
	escapes := #( 0 '\0' 7 '\a' 8 '\b' 9 '\t' 10 '\n' 12 '\f' 13 '\r' 34 '\"' 92 '\\' ).
	1 to: escapes size - 1 by: 2 do: [ :index | 
		table 
			at: (escapes at: index) + 1
			put: (escapes at: index + 1) ]! !

!WAJsonEncoder class methodsFor: 'private' stamp: 'pmm 5/6/2012 15:20'!
maximumCharacterValue
	"Everything higher is safe."
	
	^ 16r7F! !

!WAJsonEncoder methodsFor: 'accessing' stamp: 'pmm 5/6/2012 15:27'!
nextPut: aCharacter 
	| index encoded |
	index := aCharacter greaseInteger + 1.
	index > table size ifTrue: [
		stream nextPut: aCharacter.
		^ self ].
	encoded := table at: index.
	"Issue 482: use #notNil because it is faster than #isString because it is not actually sent"
	encoded notNil
		ifTrue: [ stream nextPutAll: encoded ]
		ifFalse: [ stream nextPut: aCharacter ]! !

!GRCodecStream methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:41'!
json: anObject
	| document context canvas |
	document := WAJsonDocument on: self.
	context := WARenderContext new
		actionUrl: WAUrl new;
		document: document;
		yourself.
	canvas := WAJsonCanvas context: context.
	canvas render: anObject.
	document close! !

!Integer methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:25'!
jsonOn: aRenderer
	aRenderer number: self! !

WADocument subclass: #WAJsonDocument
	instanceVariableNames: 'jsonEncoder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeArray
	stream nextPut: $]! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 12:08'!
closeObject
	stream nextPut: $}! !

!WAJsonDocument methodsFor: 'initialization' stamp: 'pmm 5/6/2012 15:30'!
initializeWithStream: aStream codec: aCodec
	super initializeWithStream: aStream codec: aCodec.
	jsonEncoder := GRPlatform current jsonEncoderOn: aStream.! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openArray
	stream nextPut: $[! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 8/24/2011 14:04'!
openObject
	stream nextPut: ${! !

!WAJsonDocument methodsFor: 'writing' stamp: 'pmm 5/6/2012 15:34'!
string: aString
	stream nextPut: $".
	jsonEncoder nextPutAll: aString.
	stream nextPut: $"! !

!Boolean methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:17'!
jsonOn: aRenderer
	aRenderer boolean: self! !

!Stream methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:42'!
json: anObject
	| document context canvas |
	document := WAJsonDocument on: self.
	context := WARenderContext new
		actionUrl: WAUrl new;
		document: document;
		yourself.
	canvas := WAJsonCanvas context: context.
	canvas render: anObject.
	document close! !

!Object methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:32'!
asJson
	^ WAJsonCanvas builder render: [ :json |
		self jsonOn: json ]! !

!Object methodsFor: '*seaside-json-core' stamp: 'lr 2/6/2010 12:39'!
jsonOn: aStream
	self error: 'Override #jsonOn: to make the receiver serializeable as JSON'! !

!String methodsFor: '*seaside-json-core' stamp: 'pmm 2/18/2012 15:21'!
jsonOn: aRenderer
	aRenderer string: self! !

WABrush subclass: #WAJsonBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

WAJsonBrush subclass: #WAJsonArrayBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:09'!
closeBrush
	self document closeArray! !

!WAJsonArrayBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openArray! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:08'!
closeBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'accessing' stamp: 'pmm 8/24/2011 14:06'!
document
	^ canvas document! !

!WAJsonBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:00'!
openBrush
	self subclassResponsibility! !

!WAJsonBrush methodsFor: 'public' stamp: 'pmm 8/24/2011 14:07'!
with: anObject

	self openBrush.
	super with: [
		canvas render: anObject ].
	self closeBrush! !

WAJsonBrush subclass: #WAJsonElementBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonElementBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 15:11'!
closeBrush! !

!WAJsonElementBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 15:11'!
openBrush
	canvas writeIfNotFirst: ', '! !

WAJsonElementBrush subclass: #WAJsonKeyValueBrush
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonKeyValueBrush class methodsFor: 'instance creation' stamp: 'pmm 8/24/2011 15:10'!
key: aString
	^ self basicNew initializeWithKey: aString! !

!WAJsonKeyValueBrush methodsFor: 'initialization' stamp: 'pmm 8/24/2011 15:10'!
initializeWithKey: aString
	self initialize.
	key := aString! !

!WAJsonKeyValueBrush methodsFor: 'private' stamp: 'pmm 2/18/2012 15:16'!
openBrush
	super openBrush.
	key jsonOn: canvas.
	self document stream nextPutAll: ': '! !

WAJsonElementBrush subclass: #WAJsonValueBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

WAJsonBrush subclass: #WAJsonObjectBrush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-JSON-Core'!

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 12:10'!
closeBrush
	self document closeObject! !

!WAJsonObjectBrush methodsFor: 'private' stamp: 'pmm 8/24/2011 14:05'!
openBrush
	self document openObject! !
WAJsonEncoder initialize!
